package pong;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.EventQueue;
import java.awt.Font;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;

public class Main extends JFrame implements Runnable {

	private int x = 128, y = 128, vx = -8, vy = 8;
	private JLabel lblCursore1;
	private JLabel lblPalla;
	private JLabel lblCursore2;
	private boolean running = false;
	private JPanel panel;
	private JLabel lblPunteggio1;
	private JLabel lblPunteggio2;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main frame = new Main();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public Main() {
		addKeyListener(new KeyAdapter() {
			@Override
			public void keyTyped(KeyEvent ke) {
				tastoPremuto(ke);
			}
		});
		setTitle("Pong");
		setBounds(100, 100, 817, 445);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		panel = new JPanel();
		panel.setForeground(Color.WHITE);
		panel.setBackground(Color.BLACK);
		getContentPane().add(panel, BorderLayout.CENTER);
		panel.setLayout(null);

		lblCursore1 = new JLabel("");
		lblCursore1.setIcon(new ImageIcon(Main.class
				.getResource("/pong/img/cursore.png")));
		lblCursore1.setBounds(24, 32, 8, 32);
		panel.add(lblCursore1);

		lblCursore2 = new JLabel("");
		lblCursore2.setIcon(new ImageIcon(Main.class
				.getResource("/pong/img/cursore.png")));
		lblCursore2.setBounds(760, 127, 8, 32);
		panel.add(lblCursore2);

		JLabel lblRete = new JLabel("");
		lblRete.setIcon(new ImageIcon(Main.class
				.getResource("/pong/img/rete.png")));
		lblRete.setBounds(400, 0, 8, 512);
		panel.add(lblRete);

		lblPalla = new JLabel("");
		lblPalla.setIcon(new ImageIcon(Main.class
				.getResource("/pong/img/palla.png")));
		lblPalla.setBounds(128, 128, 8, 8);
		panel.add(lblPalla);

		lblPunteggio1 = new JLabel("0");
		lblPunteggio1.setHorizontalAlignment(SwingConstants.RIGHT);
		lblPunteggio1.setFont(new Font("OCR A Extended", Font.PLAIN, 48));
		lblPunteggio1.setForeground(Color.WHITE);
		lblPunteggio1.setBounds(337, 11, 53, 53);
		panel.add(lblPunteggio1);

		lblPunteggio2 = new JLabel("0");
		lblPunteggio2.setHorizontalAlignment(SwingConstants.LEFT);
		lblPunteggio2.setForeground(Color.WHITE);
		lblPunteggio2.setFont(new Font("OCR A Extended", Font.PLAIN, 48));
		lblPunteggio2.setBounds(418, 11, 53, 53);
		panel.add(lblPunteggio2);

		Thread t = new Thread(this);
		t.setDaemon(true);
		running = true;
		t.start();
	}

	public void tastoPremuto(KeyEvent ke) {
		switch (ke.getKeyChar()) {
		case 'q':
			lblCursore1.setLocation(lblCursore1.getX(), lblCursore1.getY() - 8);
			break;
		case 'a':
			lblCursore1.setLocation(lblCursore1.getX(), lblCursore1.getY() + 8);
			break;
		case 'p':
			lblCursore2.setLocation(lblCursore2.getX(), lblCursore2.getY() - 8);
			break;
		case 'l':
			lblCursore2.setLocation(lblCursore2.getX(), lblCursore2.getY() + 8);
			break;
		}
	}

	@Override
	public void run() {
		while (running) {
			int x = lblPalla.getX();
			int y = lblPalla.getY();
			x += vx;
			y += vy;
			if (x<=lblCursore1.getX()+8 && x>lblCursore1.getX() && y>=lblCursore1.getY() && y<lblCursore1.getY()+32-8) {
				vx = -vx;
				lblPunteggio1.setText(""+(Integer.parseInt(lblPunteggio1.getText())+1));
			}
			if (x>=lblCursore2.getX()-8 && x<lblCursore2.getX() && y>=lblCursore2.getY() && y<lblCursore2.getY()+32-8) {
				vx = -vx;
				lblPunteggio2.setText(""+(Integer.parseInt(lblPunteggio2.getText())+1));
			}
			if (y < 8 || y > panel.getHeight() - 8)
				vy = -vy;
			lblPalla.setLocation(x, y);
			try {
				Thread.sleep(100);
			} catch (InterruptedException e) {
			}
		}
	}

}
